diff -Naur /users/iupisi/isi2g0/TP_JUnit/Depot/Opale/src/units/m3d/TestMatrix3D.java Opale/src/units/m3d/TestMatrix3D.java
--- /users/iupisi/isi2g0/TP_JUnit/Depot/Opale/src/units/m3d/TestMatrix3D.java
+++ Opale/src/units/m3d/TestMatrix3D.java	Fri Feb 20 15:31:09 2004
@@ -0,0 +1,155 @@
+package m3d ;
+
+import junit.framework.TestCase ;
+import opale.m3d.Matrix3D ;
+
+public class TestMatrix3D extends TestCase
+{
+	public void testConstructors ()
+	{
+		Matrix3D m1 = new Matrix3D () ;
+		
+		assertTrue (m1.getA00() == 1) ;
+		assertTrue (m1.getA11() == 1) ;
+		assertTrue (m1.getA22() == 1) ;
+		assertTrue (m1.getA01() == 0) ;
+		assertTrue (m1.getA02() == 0) ;
+		assertTrue (m1.getA03() == 0) ;
+		assertTrue (m1.getA10() == 0) ;
+		assertTrue (m1.getA12() == 0) ;
+		assertTrue (m1.getA13() == 0) ;
+		assertTrue (m1.getA20() == 0) ;
+		assertTrue (m1.getA21() == 0) ;
+		assertTrue (m1.getA23() == 0) ;
+	}
+	
+	public void testSetToIdentity ()
+	{
+		Matrix3D m1 = new Matrix3D () ;
+		double [] d1 = {5.3, -4.3, 8.2}, d2 = {-0.5, 6.7, 12.3},
+			d3 = {-1, 2.3, 5.4}, d4 = {8, -4.3, 5.4} ;
+		m1.setColumn (1, d1) ;
+		m1.setColumn (2, d2) ;
+		m1.setColumn (3, d3) ;
+		m1.setColumn (4, d4) ;
+
+		m1.setToIdentity () ;
+
+		assertTrue (m1.getA00() == 1) ;
+		assertTrue (m1.getA11() == 1) ;
+		assertTrue (m1.getA22() == 1) ;
+		assertTrue (m1.getA01() == 0) ;
+		assertTrue (m1.getA02() == 0) ;
+		assertTrue (m1.getA03() == 0) ;
+		assertTrue (m1.getA10() == 0) ;
+		assertTrue (m1.getA12() == 0) ;
+		assertTrue (m1.getA13() == 0) ;
+		assertTrue (m1.getA20() == 0) ;
+		assertTrue (m1.getA21() == 0) ;
+		assertTrue (m1.getA23() == 0) ;
+	}
+	
+	public void testGetColumn ()
+	{
+		Matrix3D m1 = new Matrix3D () ;
+		double [] d1 = {5.3, -4.3, 8.2}, d2 = {-0.5, 6.7, 12.3},
+			d3 = {-1, 2.3, 5.4}, d4 = {8, -4.3, 5.4} ;
+		double [] r1, r2, r3, r4 ;
+
+		m1.setA00 (d1 [0]) ;
+		m1.setA01 (d2 [0]) ;
+		m1.setA02 (d3 [0]) ;
+		m1.setA03 (d4 [0]) ;
+		m1.setA10 (d1 [1]) ;
+		m1.setA11 (d2 [1]) ;
+		m1.setA12 (d3 [1]) ;
+		m1.setA13 (d4 [1]) ;
+		m1.setA20 (d1 [2]) ;
+		m1.setA21 (d2 [2]) ;
+		m1.setA22 (d3 [2]) ;
+		m1.setA23 (d4 [2]) ;
+		
+		r1 = m1.getColumn (1) ;
+		r2 = m1.getColumn (2) ;
+		r3 = m1.getColumn (3) ;
+		r4 = m1.getColumn (4) ;
+
+		for (int i = 0 ; i < 3 ; i++)
+		{
+			assertTrue (r1 [i] == d1 [i]) ;
+			assertTrue (r2 [i] == d2 [i]) ;
+			assertTrue (r3 [i] == d3 [i]) ;
+			assertTrue (r4 [i] == d4 [i]) ;
+		}	
+	}
+	
+	public void testSetColumn ()
+	{
+		Matrix3D m1 = new Matrix3D () ;
+		double [] d1 = {5.3, -4.3, 8.2}, d2 = {-0.5, 6.7, 12.3},
+			d3 = {-1, 2.3, 5.4}, d4 = {8, -4.3, 5.4} ;
+
+		m1.setColumn (1, d1) ;
+		m1.setColumn (2, d2) ;
+		m1.setColumn (3, d3) ;
+		m1.setColumn (4, d4) ;
+		
+		assertTrue (m1.getA00 () == d1 [0]) ;
+		assertTrue (m1.getA01 () == d2 [0]) ;
+		assertTrue (m1.getA02 () == d3 [0]) ;
+		assertTrue (m1.getA03 () == d4 [0]) ;
+		assertTrue (m1.getA10 () == d1 [1]) ;
+		assertTrue (m1.getA11 () == d2 [1]) ;
+		assertTrue (m1.getA12 () == d3 [1]) ;
+		assertTrue (m1.getA13 () == d4 [1]) ;
+		assertTrue (m1.getA20 () == d1 [2]) ;
+		assertTrue (m1.getA21 () == d2 [2]) ;
+		assertTrue (m1.getA22 () == d3 [2]) ;
+		assertTrue (m1.getA23 () == d4 [2]) ;
+	}
+	
+	public void testCompute ()
+	{
+		Matrix3D m1 = new Matrix3D () ;
+		double [] d1 = {5.3, -4.3, 8.2}, d2 = {-0.5, 6.7, 12.3},
+			d3 = {-1, 2.3, 5.4}, d4 = {8, -4.3, 5.4} ;
+		double [] p = {5.7, -6.1, 2} ;
+		double [] r ;
+
+		m1.setColumn (1, d1) ;
+		m1.setColumn (2, d2) ;
+		m1.setColumn (3, d3) ;
+		m1.setColumn (4, d4) ;
+		
+		r = m1.compute (p[0], p[1], p[2]) ;
+		
+		assertTrue (r[0] == (d1[0] * p[0] + d2[0] * p[1] + d3[0] * p[2] + d4[0])) ;
+		assertTrue (r[1] == (d1[1] * p[0] + d2[1] * p[1] + d3[1] * p[2] + d4[1])) ;
+		assertTrue (r[2] == (d1[2] * p[0] + d2[2] * p[1] + d3[2] * p[2] + d4[2])) ;
+	}
+	
+	public void testGetInvert ()
+	{
+		Matrix3D m1 = new Matrix3D () ;
+		double [] d1 = {5.3, -4.3, 8.2}, d2 = {-0.5, 6.7, 12.3},
+			d3 = {-1, 2.3, 5.4}, d4 = {8, -4.3, 5.4} ;
+		double [][] r ;
+
+		m1.setColumn (1, d1) ;
+		m1.setColumn (2, d2) ;
+		m1.setColumn (3, d3) ;
+		m1.setColumn (4, d4) ;
+
+		r = m1.getInvert () ;
+		
+	}
+	
+	public void testGetA00 ()
+	{
+		Matrix3D m1 = new Matrix3D () ;
+		m1.setA00 (5.3) ;
+
+		assertTrue (m1.getA00 () == 5.3) ;
+	}
+
+}
diff -Naur /users/iupisi/isi2g0/TP_JUnit/Depot/Opale/src/units/m3d/TestOIJK.java Opale/src/units/m3d/TestOIJK.java
--- /users/iupisi/isi2g0/TP_JUnit/Depot/Opale/src/units/m3d/TestOIJK.java
+++ Opale/src/units/m3d/TestOIJK.java	Fri Feb 20 14:16:40 2004
@@ -0,0 +1,8 @@
+package m3d ;
+
+import junit.framework.TestCase ;
+import opale.m3d.OIJK ;
+
+public class TestOIJK extends TestCase
+{
+}