Index: src/sound.cpp
===================================================================
--- src/sound.cpp	(revision 1794)
+++ src/sound.cpp	(working copy)
@@ -88,7 +88,7 @@
 
     if (Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT, 2, 1024) == -1)
     {
-        std::cerr <<_("Couldn't initialize SDL-mixer\n");
+        std::cerr << "Couldn't initialize SDL-mixer\n";
         std::cerr <<Mix_GetError() <<std::endl;
         d_broken = true;
         return;
@@ -99,7 +99,7 @@
 
     if (!helper.parse())
     {
-        std::cerr<<_("Error loading music descriptions; disable music\n");
+        std::cerr<< "Error loading music descriptions; disable music\n";
         d_broken = true;
         Mix_CloseAudio();
 	return;
Index: src/gamebigmap.cpp
===================================================================
--- src/gamebigmap.cpp	(revision 1794)
+++ src/gamebigmap.cpp	(working copy)
@@ -98,7 +98,7 @@
   if (!stack->getPath()->checkPath(stack))
     {
       //error handling is required here, up to now we only barf on cerr
-      cerr << _("original path of stack was blocked\n");
+      cerr << "original path of stack was blocked\n";
     }
 
   stack_selected.emit(stack);
@@ -180,7 +180,7 @@
 
 	  int dist = stack->getPath()->calculate(stack, p);
 	  if (dist == -2)
-	    cerr << _("error calculating path!");
+	    cerr << "error calculating path!";
 
 	  Vector<int>* dest = 0;
 	  if (!stack->getPath()->empty())
Index: src/Configuration.cpp
===================================================================
--- src/Configuration.cpp	(revision 1794)
+++ src/Configuration.cpp	(working copy)
@@ -157,7 +157,7 @@
     
     if (!retval)
     {
-        std::cerr <<_("Configuration: Something went wrong while saving.\n");
+        std::cerr << "Configuration: Something went wrong while saving.\n";
         return false;
     }
     
@@ -192,7 +192,7 @@
 	    //            string orig = string(getenv("HOME"))+s_filename;
 	    //            string dest = string(getenv("HOME"))+s_filename+".OLD";
 	    //#endif
-            cerr <<_("I make a backup copy from ") << orig << " to " << dest << endl;
+            cerr << "I make a backup copy from " << orig << " to " << dest << endl;
 
             ofstream ofs(dest.c_str());
 	    ifstream ifs(orig.c_str());
@@ -300,12 +300,12 @@
 	bool saveconf = conf.saveConfigurationFile(Configuration::configuration_file_path);
 	if (!saveconf)
 	{
-            std::cerr << _("Couldn't save the new configuration file...") << std::endl;
-            std::cerr << _("Check permissions of your home directory....aborting!") << std::endl;
+            std::cerr << "Couldn't save the new configuration file..." << std::endl;
+            std::cerr << "Check permissions of your home directory....aborting!" << std::endl;
 	    exit(-1);
 	}
 	else
-	    std::cerr <<_("Created the standard configuration file ") << Configuration::configuration_file_path << std::endl;
+	    std::cerr << "Created the standard configuration file " << Configuration::configuration_file_path << std::endl;
     }
     
 #ifndef __WIN32__
@@ -318,9 +318,9 @@
         Uint32 mask = 0755; //make directory only readable for user and group
         if (mkdir(Configuration::s_savePath.c_str(), mask))
         {
-            std::cerr <<_("Couldn't create save game directory ");
+            std::cerr << "Couldn't create save game directory ";
             std::cerr << Configuration::s_savePath <<".\n";
-            std::cerr <<_("Check permissions and the entries in your lordsawarrc file!") << std::endl;
+            std::cerr << "Check permissions and the entries in your lordsawarrc file!" << std::endl;
             exit(-1);
         }
     }
Index: src/GameScenario.cpp
===================================================================
--- src/GameScenario.cpp	(revision 1794)
+++ src/GameScenario.cpp	(working copy)
@@ -353,12 +353,12 @@
 
   if (strtoken->getLastToken() == extension)
     {
-      debug(_("The Filename is well formed"))
+      debug("The Filename is well formed")
 	std::cerr <<"";  //dummy call if debug statement is commented out
     }
   else 
     {
-      debug(_("The Filename lacks the extension --> ") << extension)
+      debug("The Filename lacks the extension --> " << extension)
 	goodfilename += "." + extension;
     }
 
@@ -371,7 +371,7 @@
   if (retval)
     return true;
 
-  std::cerr <<_("GameScenario: Something went wrong with saving.\n");
+  std::cerr << "GameScenario: Something went wrong with saving.\n";
   return false;
 }
 
@@ -439,9 +439,9 @@
     {
       if (helper->getVersion() != LORDSAWAR_SAVEGAME_VERSION)
 	{
-	  cerr <<_("savefile has wrong version, we want ");
+	  cerr << "savefile has wrong version, we want ";
 	  std::cerr <<LORDSAWAR_SAVEGAME_VERSION <<",\n";
-	  cerr <<_("savefile offers ") <<helper->getVersion() <<".\n";
+	  cerr << "savefile offers " <<helper->getVersion() <<".\n";
 	  return false;
 	}
 
@@ -618,15 +618,15 @@
   // (and we have a savefile for debugging)
   if (!saveGame(File::getSavePath() + "tmp.sav"))
     {
-      std::cerr<<_("Autosave failed.\n");
+      std::cerr<< "Autosave failed.\n";
       return;
     }
   if (rename(std::string(File::getSavePath() + "tmp.sav").c_str(),
 	     std::string(File::getSavePath() + filename).c_str()))
     {
       char* err = strerror(errno);
-      std::cerr <<_("Error while trying to rename the temporary file to autosave.sav\n");
-      std::cerr <<_("Error: ") <<err <<std::endl;
+      std::cerr << "Error while trying to rename the temporary file to autosave.sav\n";
+      std::cerr << "Error: " <<err <<std::endl;
     }
 }
 
Index: src/xmlhelper.cpp
===================================================================
--- src/xmlhelper.cpp	(revision 1794)
+++ src/xmlhelper.cpp	(working copy)
@@ -50,7 +50,7 @@
     // is propably possible, but there is little point in using it anyway.
     if ((mode & std::ios::in) && (mode & std::ios::out))
     {
-        std::cerr <<_("XML_Helper: Either open file for reading or writing, not both, exiting\n");
+        std::cerr << "XML_Helper: Either open file for reading or writing, not both, exiting\n";
         exit(-1);
     }
 
@@ -62,7 +62,7 @@
         if (!(*d_fin))
         //error opening
         {
-            std::cerr <<filename <<_(": Error opening file for reading. Exiting\n");
+            std::cerr <<filename << ": Error opening file for reading. Exiting\n";
             exit(-1);
         }
 
@@ -72,13 +72,13 @@
 
         if (d_fin->eof())
         {
-            std::cerr <<_("File too short (<=1 byte), propably broken. Skipping load\n");
+            std::cerr << "File too short (<=1 byte), propably broken. Skipping load\n";
             d_failed = true;
         }
 
         if (tmp=='Z') 
         {  
-            std::cout <<filename <<_(": The file is obfuscated, attempting to read it....\n"); 
+            std::cout <<filename << ": The file is obfuscated, attempting to read it....\n"; 
             d_fin->seekg (0,std::ios::end);
             long length = d_fin->tellg();
             d_fin->seekg (1, std::ios::beg);    
@@ -121,7 +121,7 @@
                                    std::ios::out & std::ios::trunc);
         if (!(*d_fout))
         {
-            std::cerr <<filename <<_(": Error opening file for writing. Exiting\n");
+            std::cerr <<filename << ": Error opening file for writing. Exiting\n";
             exit(-1);
         }
 
@@ -148,7 +148,7 @@
 {
     if (d_tags.size() != 0)
     // should never happen unless there was an error
-        std::cerr <<_("XML_Helper: dtags not empty!!\n");
+        std::cerr << "XML_Helper: dtags not empty!!\n";
     
     debug("Called destructor\n")    
     close();
@@ -166,13 +166,13 @@
 {
     if (!d_out)
     {
-        std::cerr <<_("XML_Helper: no output stream given\n");
+        std::cerr << "XML_Helper: no output stream given\n";
         return false;
     }
 
     if ((name[0] == 'd') && (name[1] == '_'))
     {
-        std::cerr <<name <<_(": The tag name starts with a \"d\". Not creating tag!\n");
+        std::cerr <<name << ": The tag name starts with a \"d\". Not creating tag!\n";
         return false;
     }
 
@@ -192,7 +192,7 @@
 {
     if (!d_out)
     {
-        std::cerr <<_("XML_Helper: no output stream given.\n");
+        std::cerr << "XML_Helper: no output stream given.\n";
         return false;
     }
 
@@ -214,12 +214,12 @@
 
     if (name.empty())
     {
-        std::cerr <<_("XML_Helper: save_data with empty name\n");
+        std::cerr << "XML_Helper: save_data with empty name\n";
         return false;
     }
     if (!d_out)
     {
-        std::cerr <<_("XML_Helper: no output stream given.\n");
+        std::cerr << "XML_Helper: no output stream given.\n";
         return false;
     }
 
@@ -235,12 +235,12 @@
 
     if (name.empty())
     {
-        std::cerr <<_("XML_Helper: save_data with empty name\n");
+        std::cerr << "XML_Helper: save_data with empty name\n";
         return false;
     }
     if (!d_out)
     {
-        std::cerr <<_("XML_Helper: no output stream given.\n");
+        std::cerr << "XML_Helper: no output stream given.\n";
         return false;
     }
 
@@ -256,12 +256,12 @@
 
     if (name.empty())
     {
-        std::cerr <<_("XML_Helper: save_data with empty name\n");
+        std::cerr << "XML_Helper: save_data with empty name\n";
         return false;
     }
     if (!d_out)
     {
-        std::cerr <<_("XML_Helper: no output stream given.\n");
+        std::cerr << "XML_Helper: no output stream given.\n";
         return false;
     }
 
@@ -277,12 +277,12 @@
 
     if (name.empty())
     {
-        std::cerr <<_("XML_Helper: save_data with empty name\n");
+        std::cerr << "XML_Helper: save_data with empty name\n";
         return false;
     }
     if (!d_out)
     {
-        std::cerr <<_("XML_Helper: no output stream given.\n");
+        std::cerr << "XML_Helper: no output stream given.\n";
         return false;
     }
 
@@ -301,12 +301,12 @@
 
     if (name.empty())
     {
-        std::cerr <<_("XML_Helper: save_data with empty name\n");
+        std::cerr << "XML_Helper: save_data with empty name\n";
         return false;
     }
     if (!d_out)
     {
-        std::cerr <<_("XML_Helper: no output stream given.\n");
+        std::cerr << "XML_Helper: no output stream given.\n";
         return false;
     }
 
@@ -329,7 +329,7 @@
         if (d_zip)        
         {
             debug("I zip IT")
-            debug(_("Saving game and obfuscating the Savefile.\n")) 
+            debug("Saving game and obfuscating the Savefile.\n") 
             std::string tmp = d_outbuf->str();
             tmp+='\0';
 
@@ -557,10 +557,10 @@
         if (!XML_ParseBuffer(d_parser, strlen(buffer), my_eof))
         //error parsing
         {
-            std::cerr <<_("XML_Helper: error parsing xml document.\n");
-            std::cerr <<_("Line ") <<XML_GetCurrentLineNumber(d_parser);
+            std::cerr <<"XML_Helper: error parsing xml document.\n";
+            std::cerr <<"Line " <<XML_GetCurrentLineNumber(d_parser);
             std::cerr <<": " <<XML_ErrorString(XML_GetErrorCode(d_parser)) <<"\n";
-            std::cerr << _("Buffercontent = ") << buffer << std::endl;
+            std::cerr <<"Buffercontent = " << buffer << std::endl;
             d_failed = true;
         }
     }
@@ -630,7 +630,7 @@
             bool retval = (it->second)(*ls_it, this);
             if (retval == false)
             {
-                std::cerr <<(*ls_it) <<_(": Callback for tag returned false. Stop parsing document.\n");
+                std::cerr <<(*ls_it) << ": Callback for tag returned false. Stop parsing document.\n";
                 error = true;
                 d_failed = true;
             }
@@ -673,7 +673,7 @@
             
             if (retval == false)
             {
-                std::cerr <<tag <<_(": Callback for tag returned false. Stop parsing document.\n");
+                std::cerr <<tag <<": Callback for tag returned false. Stop parsing document.\n";
                 error = true;
                 d_failed = true;
             }
Index: src/File.cpp
===================================================================
--- src/File.cpp	(revision 1794)
+++ src/File.cpp	(working copy)
@@ -123,9 +123,9 @@
 
     if (retlist.empty())
     {
-      std::cerr << _("Couldn't find any armysets!") << std::endl;
-      std::cerr << _("Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc") << std::endl;
-      std::cerr << _("Exiting!") << std::endl;
+      std::cerr << "Couldn't find any armysets!" << std::endl;
+      std::cerr << "Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc" << std::endl;
+      std::cerr << "Exiting!" << std::endl;
       exit(-1);
     }
 
@@ -199,9 +199,9 @@
     
     if (retlist.empty())
     {
-      std::cerr << _("Couldn't find any tilesets!") << std::endl;
-      std::cerr << _("Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc") << std::endl;
-      std::cerr << _("Exiting!") << std::endl;
+      std::cerr << "Couldn't find any tilesets!" << std::endl;
+      std::cerr << "Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc" << std::endl;
+      std::cerr << "Exiting!" << std::endl;
       exit(-1);
     }
     
@@ -215,9 +215,9 @@
     
     if (retlist.empty())
     {
-      std::cerr << _("Couldn't find any citysets!") << std::endl;
-      std::cerr << _("Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc") << std::endl;
-      std::cerr << _("Exiting!") << std::endl;
+      std::cerr << "Couldn't find any citysets!" << std::endl;
+      std::cerr << "Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc" << std::endl;
+      std::cerr << "Exiting!" << std::endl;
         exit(-1);
     }
     
@@ -243,8 +243,8 @@
     
     if (retlist.empty())
     {
-      std::cerr << _("Couldn't find a single campaign!") << std::endl;
-      std::cerr << _("Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc") << std::endl;
+      std::cerr << "Couldn't find a single campaign!" << std::endl;
+      std::cerr << "Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc" << std::endl;
     }
 
     //now we find the ones that are pointed to, and remove them
@@ -284,8 +284,8 @@
     
     if (retlist.empty())
     {
-      std::cerr << _("Couldn't find a single map!") << std::endl;
-      std::cerr << _("Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc") << std::endl;
+      std::cerr << "Couldn't find a single map!" << std::endl;
+      std::cerr << "Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc" << std::endl;
     }
 
     return retlist;
@@ -298,9 +298,9 @@
 
     if (retlist.empty())
     {
-      std::cerr << _("Couldn't find any shieldsets!") << std::endl;
-      std::cerr << _("Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc") << std::endl;
-      std::cerr << _("Exiting!") << std::endl;
+      std::cerr << "Couldn't find any shieldsets!" << std::endl;
+      std::cerr << "Please check the path settings in /etc/lordsawarrc or ~/.lordsawarrc" << std::endl;
+      std::cerr << "Exiting!" << std::endl;
       exit(-1);
     }
 
Index: src/citysetlist.cpp
===================================================================
--- src/citysetlist.cpp	(revision 1794)
+++ src/citysetlist.cpp	(working copy)
@@ -111,7 +111,7 @@
 
   if (!helper.parse())
     {
-      std::cerr <<_("Error, while loading a cityset. Cityset Name: ");
+      std::cerr << "Error, while loading a cityset. Cityset Name: ";
       std::cerr <<name <<std::endl <<std::flush;
       exit(-1);
     }
Index: src/GraphicsCache.cpp
===================================================================
--- src/GraphicsCache.cpp	(revision 1794)
+++ src/GraphicsCache.cpp	(working copy)
@@ -740,7 +740,7 @@
 
     if (!s)
     {
-        std::cerr <<_("GraphicsCache::getFlagPic: no stack supplied! Exiting...\n");
+        std::cerr << "GraphicsCache::getFlagPic: no stack supplied! Exiting...\n";
         exit(-1);
     }
     
@@ -773,7 +773,7 @@
 
     if (!p)
     {
-        std::cerr <<_("GraphicsCache::getSelectorPic: no player supplied! Exiting...\n");
+        std::cerr << "GraphicsCache::getSelectorPic: no player supplied! Exiting...\n";
         exit(-1);
     }
     
Index: src/MapGenerator.cpp
===================================================================
--- src/MapGenerator.cpp	(revision 1794)
+++ src/MapGenerator.cpp	(working copy)
@@ -40,8 +40,8 @@
 #include "armysetlist.h"
 #include "army.h"
 
-//#define debug(x) {std::cerr<<__FILE__<<": "<<__LINE__<<": "<<x<<std::endl<<std::flush;}
-#define debug(x)
+#define debug(x) {std::cerr<<__FILE__<<": "<<__LINE__<<": "<<x<<std::endl<<std::flush;}
+//#define debug(x)
 #define offmap(bx,by) (by<0)||(by>=d_height)||(bx<0)||(bx>=d_width)
 
 using namespace std;
Index: src/playerlist.cpp
===================================================================
--- src/playerlist.cpp	(revision 1794)
+++ src/playerlist.cpp	(working copy)
@@ -309,7 +309,7 @@
       _("Diplomat"),
       _("Pragmatist"),
       _("Politician"),
-      _("Deciever"),
+      _("Deceiver"),
       _("Scoundrel"),
       _("Turncoat"),
       _("Running Dog"),
Index: src/tilesetlist.cpp
===================================================================
--- src/tilesetlist.cpp	(revision 1794)
+++ src/tilesetlist.cpp	(working copy)
@@ -132,7 +132,7 @@
 
   if (!helper.parse())
     {
-      std::cerr <<_("Error, while loading a tileset. Tileset Name: ");
+      std::cerr << "Error, while loading a tileset. Tileset Name: ";
       std::cerr <<name <<std::endl <<std::flush;
       exit(-1);
     }
Index: src/tileset.cpp
===================================================================
--- src/tileset.cpp	(revision 1794)
+++ src/tileset.cpp	(working copy)
@@ -216,7 +216,7 @@
     {
       if ((*i)->validate() == false)
 	{
-	  fprintf (stderr, _("`%s' fails validation\n"), 
+	  fprintf (stderr, "`%s' fails validation\n", 
 		   (*i)->getName().c_str());
 	  return false;
 	}
Index: src/CreateScenario.cpp
===================================================================
--- src/CreateScenario.cpp	(revision 1794)
+++ src/CreateScenario.cpp	(working copy)
@@ -197,7 +197,7 @@
 
     if (width < 0)
     {
-        std::cerr <<_("CreateScenario:: wrong width given\n");
+        std::cerr << "CreateScenario:: wrong width given\n";
         return;
     }
 
@@ -212,7 +212,7 @@
 
     if (height < 0)
     {
-        std::cerr <<_("CreateScenario:: wrong height given\n");
+        std::cerr << "CreateScenario:: wrong height given\n";
         return;
     }
 
Index: src/armysetlist.cpp
===================================================================
--- src/armysetlist.cpp	(revision 1794)
+++ src/armysetlist.cpp	(working copy)
@@ -191,7 +191,7 @@
 
   if (!helper.parse())
     {
-      std::cerr <<_("Error, while loading an armyset. Armyset Name: ");
+      std::cerr << "Error, while loading an armyset. Armyset Name: ";
       std::cerr <<name <<std::endl <<std::flush;
       exit(-1);
     }
Index: src/GameMap.cpp
===================================================================
--- src/GameMap.cpp	(revision 1794)
+++ src/GameMap.cpp	(working copy)
@@ -234,7 +234,7 @@
     //the sizes should definitely match, else we have a problem here
     if (width != s_width || height != s_height)
     {
-        std::cerr <<_("Error in GameMap::fillMap: sizes don't match!! Exiting.\n");
+        std::cerr << "Error in GameMap::fillMap: sizes don't match!! Exiting.\n";
         exit(-1);
     }
 
Index: src/player.cpp
===================================================================
--- src/player.cpp	(revision 1794)
+++ src/player.cpp	(working copy)
@@ -1284,7 +1284,7 @@
   if ((s->getPos().x != r->getPos().x) ||
       (s->getPos().y != r->getPos().y))
   {
-    cerr <<_("Error: searching stack and ruin to be searched not on same position\n");
+    cerr <<  "Error: searching stack and ruin to be searched not on same position\n" ;
     exit(-1);
   }
 
@@ -1373,7 +1373,7 @@
     if (!s || !t || (s->getPos().x != t->getPos().x) 
 	|| (s->getPos().y != t->getPos().y))
       {
-	cerr <<_("Stack tried to visit temple at wrong location\n");
+	cerr << "Stack tried to visit temple at wrong location\n";
 	exit(-1);
       }
 
Index: src/shieldsetlist.cpp
===================================================================
--- src/shieldsetlist.cpp	(revision 1794)
+++ src/shieldsetlist.cpp	(working copy)
@@ -101,7 +101,7 @@
 
   if (!helper.parse())
     {
-      std::cerr <<_("Error, while loading a shieldset. Shieldset Name: ");
+      std::cerr << "Error, while loading a shieldset. Shieldset Name: ";
       std::cerr <<name <<std::endl <<std::flush;
       exit(-1);
     }
Index: dat/glade/game-lobby-dialog.glade
===================================================================
--- dat/glade/game-lobby-dialog.glade	(revision 1794)
+++ dat/glade/game-lobby-dialog.glade	(working copy)
@@ -521,7 +521,7 @@
 				  <child>
 				    <widget class="GtkLabel" id="turn_label">
 				      <property name="visible">True</property>
-				      <property name="label" translatable="yes">0</property>
+				      <property name="label">0</property>
 				      <property name="use_underline">False</property>
 				      <property name="use_markup">False</property>
 				      <property name="justify">GTK_JUSTIFY_LEFT</property>
@@ -577,7 +577,7 @@
 				  <child>
 				    <widget class="GtkLabel" id="cities_label">
 				      <property name="visible">True</property>
-				      <property name="label" translatable="yes">0</property>
+				      <property name="label">0</property>
 				      <property name="use_underline">False</property>
 				      <property name="use_markup">False</property>
 				      <property name="justify">GTK_JUSTIFY_LEFT</property>
Index: dat/glade/game-window.glade
===================================================================
--- dat/glade/game-window.glade	(revision 1794)
+++ dat/glade/game-window.glade	(working copy)
@@ -1605,7 +1605,7 @@
 		      <child>
 			<widget class="GtkButton" id="end_turn_button">
 			  <property name="visible">True</property>
-			  <property name="tooltip" translatable="yes">End the turn</property>
+			  <property name="tooltip" translatable="yes">End Turn</property>
 			  <property name="relief">GTK_RELIEF_NORMAL</property>
 			  <property name="focus_on_click">True</property>
 
Index: dat/glade/ruinfight-started-dialog.glade
===================================================================
--- dat/glade/ruinfight-started-dialog.glade	(revision 1794)
+++ dat/glade/ruinfight-started-dialog.glade	(working copy)
@@ -61,7 +61,7 @@
 	  <child>
 	    <widget class="GtkLabel" id="label">
 	      <property name="visible">True</property>
-	      <property name="label" translatable="yes">So and so encounters a monster and....</property>
+	      <property name="label" translatable="yes">So and so encounters a monster and...</property>
 	      <property name="use_underline">False</property>
 	      <property name="use_markup">False</property>
 	      <property name="justify">GTK_JUSTIFY_LEFT</property>