diff -ruN cvs.orig/icons.cpp cvs/icons.cpp
--- cvs.orig/icons.cpp	1970-01-01 01:00:00.000000000 +0100
+++ cvs/icons.cpp	2008-08-03 18:29:23.000000000 +0200
@@ -0,0 +1,105 @@
+// Provider of icons for wx interface.
+//
+// Copyright (C) 2008 Gregory W. Chicares.
+//
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License version 2 as
+// published by the Free Software Foundation.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program; if not, write to the Free Software Foundation,
+// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+//
+// http://savannah.nongnu.org/projects/lmi
+// email: <chicares@cox.net>
+// snail: Chicares, 186 Belle Woods Drive, Glastonbury CT 06033, USA
+
+// $Id$
+
+#ifdef __BORLANDC__
+#   include "pchfile.hpp"
+#   pragma hdrstop
+#endif
+
+#include "icons.hpp"
+
+#include "data_directory.hpp"
+
+#include <wx/image.h>
+
+namespace
+{
+
+/// Return desirable size of icons, given the client that requested the icon
+/// and requested size (which should usually be unspecified)
+
+wxSize GetRealSize(wxArtClient const& client, wxSize const& size)
+{
+    if(size == wxDefaultSize)
+        {
+        // on Windows, we don't want to use wxWidgets' 16x15 default size
+        // for everything
+#ifdef __WXMSW__
+        if(client == wxART_MENU)
+            return wxSize(16, 16);
+        else if(client == wxART_TOOLBAR)
+            return wxSize(24, 24);
+#endif
+        // fall back to defaults on other platforms and for things we don't
+        // care about:
+        return wxArtProvider::GetSizeHint(client);
+        }
+    else
+        {
+        return size;
+        }
+}
+
+} // unnamed namespace
+
+wxBitmap LMIArtProvider::CreateBitmap
+    (wxArtID const& id
+    ,wxArtClient const& client
+    ,wxSize const& size
+    )
+
+{
+    // convert wx's IDs in the form of "wxART_FOO_BAR" into nice filename
+    // such as "foo-bar"
+    wxString iconname;
+    if(id.StartsWith("wxART_", &iconname))
+        {
+        iconname.MakeLower();
+        iconname.Replace("_", "-");
+        }
+    else
+        {
+        iconname = id;
+        }
+
+    const wxSize realsize = GetRealSize(client, size);
+    const std::string basename = AddDataDir(iconname.c_str());
+
+    // try to load icon of requested size; if it cannot be found, load default
+    // size and scale it:
+    wxString file = wxString::Format("%s-%d.png", basename.c_str(), realsize.x);
+    if(!wxFileExists(file))
+        file = basename + ".png";
+
+    if(!wxFileExists(file))
+        return wxNullBitmap; // icon not provided by us
+
+    wxImage img(file, wxBITMAP_TYPE_PNG);
+    if(!img.IsOk())
+        return wxNullBitmap;
+
+    if(img.GetWidth() != realsize.x || img.GetHeight() != realsize.y)
+        img.Rescale(realsize.x, realsize.y, wxIMAGE_QUALITY_HIGH);
+
+    return wxBitmap(img);
+}
diff -ruN cvs.orig/icons.hpp cvs/icons.hpp
--- cvs.orig/icons.hpp	1970-01-01 01:00:00.000000000 +0100
+++ cvs/icons.hpp	2008-08-03 18:28:37.000000000 +0200
@@ -0,0 +1,41 @@
+// Provider of icons for wx interface.
+//
+// Copyright (C) 2008 Gregory W. Chicares.
+//
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License version 2 as
+// published by the Free Software Foundation.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program; if not, write to the Free Software Foundation,
+// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+//
+// http://savannah.nongnu.org/projects/lmi
+// email: <chicares@cox.net>
+// snail: Chicares, 186 Belle Woods Drive, Glastonbury CT 06033, USA
+
+// $Id$
+
+#ifndef icons_hpp
+#define icons_hpp
+
+#include "config.hpp"
+
+#include <wx/artprov.h>
+
+class LMIArtProvider : public wxArtProvider
+{
+  protected:
+    virtual wxBitmap CreateBitmap
+        (wxArtID const&     id
+        ,wxArtClient const& client
+        ,wxSize const&      size
+        );
+};
+
+#endif // icons_hpp
diff -ruN cvs.orig/main_wx.cpp cvs/main_wx.cpp
--- cvs.orig/main_wx.cpp	2008-08-03 19:51:04.000000000 +0200
+++ cvs/main_wx.cpp	2008-08-01 22:01:49.000000000 +0200
@@ -57,6 +57,7 @@
 #include "global_settings.hpp"
 #include "getopt.hpp"
 #include "handle_exceptions.hpp"
+#include "icons.hpp"
 #include "ihs_dbdict.hpp"           // print_databases()
 #include "illustration_document.hpp"
 #include "illustration_view.hpp"
@@ -82,6 +83,7 @@
 #include "wx_new.hpp"
 #include "wx_utility.hpp"           // class ClipboardEx
 
+#include <wx/artprov.h>
 #include <wx/config.h>
 #include <wx/cshelp.h>
 #include <wx/docmdi.h>
@@ -249,21 +251,16 @@
     return result;
 }
 
-/// 'config_' can't be initialized in the initializer list, because
-/// wxConfigBase::Get() must be called after SetAppName() and
-/// SetVendorName(). Otherwise, the configuration object wouldn't
-/// reflect the vendor and application name; on the msw platform,
-/// for instance, that would prevent writing to a registry key based
-/// on the application's name.
-///
-/// The application name contains 'wx' because it may someday become
-/// desirable to maintain different configuration information in a
-/// similar manner for other lmi user interfaces.
-///
-/// The application display name, however, omits 'wx', because:
-///  - it'll always be specific to wx; and
-///  - 'lmi' is all lowercase, but wx capitalizes the first letter of
-///     the "AppName" (but not the "AppDisplayName").
+// 'config_' can't be initialized in the initializer list, because
+// wxConfigBase::Get() must be called after SetAppName() and
+// SetVendorName(). Otherwise, the configuration object wouldn't
+// reflect the vendor and application name; on the msw platform,
+// for instance, that would prevent writing to a registry key based
+// on the application's name.
+//
+// The application name contains 'wx' because it may someday become
+// desirable to maintain different configuration information in a
+// similar manner for other lmi user interfaces.
 
 Skeleton::Skeleton()
     :doc_manager_     (0)
@@ -272,11 +269,6 @@
     ,timer_           (this)
 {
     SetAppName("lmi_wx");
-
-#if wxCHECK_VERSION(2,9,0)
-    SetAppDisplayName("lmi...");
-#endif // wxCHECK_VERSION(2,9,0)
-
     SetVendorName("lmi");
     config_ = wxConfigBase::Get();
     timer_.Start(100);
@@ -612,6 +604,16 @@
 
         authenticate_system();
 
+        wxInitAllImageHandlers();
+#ifdef __WXGTK__
+        // under GTK+, which has its own theme system, we want our icons
+        // provider to be the fallback, native icons theme takes precedence
+        wxArtProvider::Insert(new LMIArtProvider);
+#else
+        // but on other platforms, we prefer to use our own icons
+        wxArtProvider::Push(new LMIArtProvider);
+#endif
+
         wxXmlResource& xml_resources = *wxXmlResource::Get();
 
         xml_resources.InitAllHandlers();
@@ -652,7 +654,6 @@
             fatal_error() << "Unable to load Rounding resources." << LMI_FLUSH;
             }
 
-        wxInitAllImageHandlers();
         InitDocManager();
 
         frame_ = new(wx) wxDocMDIParentFrame
diff -ruN cvs.orig/Makefile.am cvs/Makefile.am
--- cvs.orig/Makefile.am	2008-08-03 19:51:04.000000000 +0200
+++ cvs/Makefile.am	2008-08-03 12:16:30.000000000 +0200
@@ -58,7 +58,7 @@
 
 # data files
 xrcdir = $(pkgdatadir)
-dist_xrc_DATA = $(shell ls -1 $(srcdir)/*.xrc $(srcdir)/*.xpm)
+dist_xrc_DATA = $(shell ls -1 $(srcdir)/*.png $(srcdir)/*.xrc $(srcdir)/*.xpm)
 
 xsldir = $(pkgdatadir)
 dist_xsl_DATA = $(shell ls -1 $(srcdir)/*.xsl)
@@ -154,6 +154,7 @@
     docmdichildframe_ex.cpp \
     facets.cpp \
     file_command_wx.cpp \
+    icons.cpp \
     illustration_document.cpp \
     illustration_view.cpp \
     main_common.cpp \
@@ -890,6 +891,7 @@
     global_settings.hpp \
     group_values.hpp \
     handle_exceptions.hpp \
+    icons.hpp \
     ihs_commfns.hpp \
     ihs_dbdict.hpp \
     ihs_dbvalue.hpp \
diff -ruN cvs.orig/menus.xrc cvs/menus.xrc
--- cvs.orig/menus.xrc	2008-08-03 19:51:04.000000000 +0200
+++ cvs/menus.xrc	2008-08-03 12:02:17.000000000 +0200
@@ -34,60 +34,60 @@
     <object class="wxMenuItem" name="wxID_NEW">
         <label>_New</label>
         <help>Create a new document</help>
-        <bitmap>new.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_NEW"/>
     </object>
     <object class="wxMenuItem" name="wxID_OPEN">
         <label>_Open...</label>
-        <bitmap>open.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_FILE_OPEN"/>
         <help>Open an existing document</help>
     </object>
     <object class="wxMenuItem" name="wxID_CLOSE">
         <label>_Close\tCtrl-X</label>
-        <bitmap>close.xpm</bitmap>
+        <bitmap platform="win" stock_id="close"/>
         <help>Close this document</help>
     </object>
     <object class="separator"/>
     <object class="wxMenuItem" name="wxID_SAVE">
         <label>_Save</label>
-        <bitmap>save.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_FILE_SAVE"/>
         <help>Save this document</help>
     </object>
     <object class="wxMenuItem" name="wxID_SAVEAS">
         <label>Save _as...</label>
-        <bitmap>saveas.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_FILE_SAVE_AS"/>
         <help>Save this document under a new name</help>
     </object>
     <object class="separator"/>
     <object class="wxMenuItem" name="wxID_PRINT">
         <label>_Print</label>
-        <bitmap>print.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_PRINT"/>
         <help>Print this document</help>
     </object>
     <object class="wxMenuItem" name="wxID_PAGE_SETUP">
         <label>Page set_up</label>
-        <bitmap>print-options.xpm</bitmap>
+        <bitmap platform="win" stock_id="print-options"/>
         <help>Choose printing options for this session</help>
     </object>
     <object class="wxMenuItem" name="wxID_PREVIEW">
         <label>Print pre_view</label>
-        <bitmap>print-preview.xpm</bitmap>
+        <bitmap platform="win" stock_id="print-preview"/>
         <help>See what this document will look like when printed</help>
     </object>
     <object class="separator"/>
     <object class="wxMenuItem" name="edit_default_cell">
         <label>_Default</label>
-        <bitmap>default_cell.xpm</bitmap>
+        <bitmap stock_id="default-cell"/>
         <help>Edit default cell</help>
     </object>
     <object class="wxMenuItem" name="wxID_PREFERENCES">
         <label>Pre_ferences\tCtrl-F</label>
-        <bitmap>preferences.xpm</bitmap>
+        <bitmap platform="win" stock_id="preferences"/>
         <help>Manage preferences</help>
     </object>
     <object class="separator"/>
     <object class="wxMenuItem" name="wxID_EXIT">
         <label>E_xit</label>
-        <bitmap>exit.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_QUIT"/>
         <help>Exit this program</help>
     </object>
 </object>
@@ -97,44 +97,44 @@
     <object class="wxMenuItem" name="wxID_NEW">
         <label>_New</label>
         <help>Create a new document</help>
-        <bitmap>new.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_NEW"/>
     </object>
     <object class="wxMenuItem" name="wxID_OPEN">
         <label>_Open...</label>
-        <bitmap>open.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_FILE_OPEN"/>
         <help>Open an existing document</help>
     </object>
     <object class="wxMenuItem" name="wxID_CLOSE">
         <label>_Close\tCtrl-X</label>
-        <bitmap>close.xpm</bitmap>
+        <bitmap platform="win" stock_id="close"/>
         <help>Close this document</help>
     </object>
     <object class="separator"/>
     <object class="wxMenuItem" name="wxID_SAVE">
         <label>_Save</label>
-        <bitmap>save.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_FILE_SAVE"/>
         <help>Save this document</help>
     </object>
     <object class="wxMenuItem" name="wxID_SAVEAS">
         <label>Save _as...</label>
-        <bitmap>saveas.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_FILE_SAVE_AS"/>
         <help>Save this document under a new name</help>
     </object>
     <object class="separator"/>
     <object class="wxMenuItem" name="edit_default_cell">
         <label>_Default</label>
-        <bitmap>default_cell.xpm</bitmap>
+        <bitmap stock_id="default-cell"/>
         <help>Edit default cell</help>
     </object>
     <object class="wxMenuItem" name="wxID_PREFERENCES">
         <label>Pre_ferences\tCtrl-F</label>
-        <bitmap>preferences.xpm</bitmap>
+        <bitmap platform="win" stock_id="preferences"/>
         <help>Manage preferences</help>
     </object>
     <object class="separator"/>
     <object class="wxMenuItem" name="wxID_EXIT">
         <label>E_xit</label>
-        <bitmap>exit.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_QUIT"/>
         <help>Exit this program</help>
     </object>
 </object>
@@ -230,13 +230,13 @@
     <help>Help</help>
     <object class="wxMenuItem" name="wxID_HELP">
         <label>_Contents\tF1</label>
-        <bitmap>help.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_HELP"/>
         <help>Read documentation</help>
     </object>
     <object class="separator"/>
     <object class="wxMenuItem" name="wxID_ABOUT">
         <label>_About...</label>
-        <bitmap>about.xpm</bitmap>
+        <bitmap platform="win" stock_id="wxART_ABOUT"/>
         <help>Read copyright and license</help>
     </object>
 </object>
@@ -256,28 +256,28 @@
         <object class="wxMenuItem" name="wxID_NEW">
             <label>_New</label>
             <help>Create a new document</help>
-            <bitmap>new.xpm</bitmap>
+            <bitmap platform="win" stock_id="wxART_NEW"/>
         </object>
         <object class="wxMenuItem" name="wxID_OPEN">
             <label>_Open...</label>
-            <bitmap>open.xpm</bitmap>
+            <bitmap platform="win" stock_id="wxART_FILE_OPEN"/>
             <help>Open an existing document</help>
         </object>
         <object class="separator"/>
         <object class="wxMenuItem" name="edit_default_cell">
             <label>_Default</label>
-            <bitmap>default_cell.xpm</bitmap>
+            <bitmap stock_id="default-cell"/>
             <help>Edit default cell</help>
         </object>
         <object class="wxMenuItem" name="wxID_PREFERENCES">
             <label>Pre_ferences\tCtrl-F</label>
-            <bitmap>preferences.xpm</bitmap>
+            <bitmap platform="win" stock_id="wxART_PREFERENCES"/>
             <help>Manage preferences</help>
         </object>
         <object class="separator"/>
         <object class="wxMenuItem" name="wxID_EXIT">
             <label>E_xit</label>
-            <bitmap>exit.xpm</bitmap>
+            <bitmap platform="win" stock_id="wxART_QUIT"/>
             <help>Exit this program</help>
         </object>
     </object>
@@ -296,85 +296,85 @@
         <label>_Census</label>
         <object class="wxMenuItem" name="edit_cell">
             <label>_Edit cell\tCtrl-E</label>
-            <bitmap>edit-cell.xpm</bitmap>
+            <bitmap stock_id="edit-cell"/>
             <help>Edit selected cell</help>
         </object>
         <object class="wxMenuItem" name="edit_class">
             <label>Edit class defaults\tCtrl-Alt-E</label>
-            <bitmap>edit-class.xpm</bitmap>
+            <bitmap stock_id="edit-class"/>
             <help>Edit selected cell's class defaults</help>
         </object>
         <object class="wxMenuItem" name="edit_case">
             <label>Edit case defaults\tCtrl-Shift-E</label>
-            <bitmap>edit-case.xpm</bitmap>
+            <bitmap stock_id="edit-case"/>
             <help>Edit case defaults</help>
         </object>
         <object class="separator"/>
         <object class="wxMenuItem" name="run_cell">
             <label>_Run selected cell\tCtrl-R</label>
-            <bitmap>run-cell.xpm</bitmap>
+            <bitmap stock_id="run-cell"/>
             <help>Run selected cell</help>
         </object>
 <!-- SOMEDAY !! This may be useful for large cases.
         <object class="wxMenuItem" name="run_class">
             <label>Run class of selected cell\tCtrl-Alt-R</label>
-            <bitmap>run-class.xpm</bitmap>
+            <bitmap stock_id="run-class"/>
             <help>Run all cells in selected cell's class</help>
         </object>
 -->
         <object class="wxMenuItem" name="run_case">
             <label>Run case\tCtrl-Shift-R</label>
-            <bitmap>run-case.xpm</bitmap>
+            <bitmap stock_id="run-case"/>
             <help>Run all cells</help>
         </object>
         <object class="separator"/>
         <object class="wxMenuItem" name="print_cell">
             <label>Run and _print selected cell\tCtrl-P</label>
-            <bitmap>print-cell.xpm</bitmap>
+            <bitmap stock_id="print-cell"/>
             <help>Run and print selected cell</help>
         </object>
 <!-- SOMEDAY !! This may be useful for large cases.
         <object class="wxMenuItem" name="print_class">
             <label>Run and print all cells in selected cell's class\tCtrl-Alt-P</label>
-            <bitmap>print-class.xpm</bitmap>
+            <bitmap stock_id="print-class"/>
             <help>Run and print all cells in selected cell's class</help>
         </object>
 -->
         <object class="wxMenuItem" name="print_case">
             <label>Run and print all cells\tCtrl-Shift-P</label>
-            <bitmap>print-case.xpm</bitmap>
+            <bitmap stock_id="print-case"/>
             <help>Run and print all cells</help>
         </object>
         <object class="wxMenuItem" name="print_spreadsheet">
             <label>Print case to spreadsheet\tCtrl-Shift-S</label>
-            <bitmap>write_spreadsheet.xpm</bitmap>
+            <bitmap stock_id="write-spreadsheet"/>
             <help>Run and print all cells to a spreadsheet file</help>
         </object>
         <object class="separator"/>
         <object class="wxMenuItem" name="paste_census">
             <label>Pa_ste census data\tCtrl-S</label>
-            <bitmap>paste-case.xpm</bitmap>
+            <bitmap stock_id="paste-case"/>
             <help>Paste census data from clipboard</help>
         </object>
         <object class="wxMenuItem" name="add_cell">
             <label>_Add cell\tCtrl-A</label>
-            <bitmap>insert-rows.xpm</bitmap>
+            <bitmap stock_id="insert-rows"/>
             <help>Add a new cell with case default parameters</help>
         </object>
         <object class="wxMenuItem" name="delete_cells">
             <label>_Delete cell(s)\tCtrl-D</label>
-            <bitmap>delete-row.xpm</bitmap>
+            <bitmap stock_id="delete-row"/>
             <help>Delete selected cell(s)</help>
         </object>
         <object class="separator"/>
         <object class="wxMenuItem" name="column_width_varying">
             <label>_Varying column width\tCtrl-V</label>
-            <bitmap>varying-width.xpm</bitmap>
+            <bitmap stock_id="varying-width"/>
             <help>Vary each column's width to show its entire contents</help>
         </object>
         <object class="wxMenuItem" name="column_width_fixed">
             <label>Fixed col_umn width\tCtrl-U</label>
-            <bitmap>fixed-width.xpm</bitmap>
+            <bitmap stock_id="fixed-width"/>
             <help>Display all columns with the same fixed width</help>
         </object>
     </object>
@@ -394,7 +394,7 @@
         <label>_Illustration</label>
         <object class="wxMenuItem" name="edit_cell">
             <label>_Edit cell\tCtrl-E</label>
-            <bitmap>edit-cell.xpm</bitmap>
+            <bitmap stock_id="edit-cell"/>
             <help>Edit this cell</help>
         </object>
         <object class="separator"/>
diff -ruN cvs.orig/objects.make cvs/objects.make
--- cvs.orig/objects.make	2008-08-03 19:51:15.000000000 +0200
+++ cvs/objects.make	2008-08-01 00:52:36.000000000 +0200
@@ -301,6 +301,7 @@
   docmanager_ex.o \
   docmdichildframe_ex.o \
   file_command_wx.o \
+  icons.o \
   illustration_document.o \
   illustration_view.o \
   main_common.o \
diff -ruN cvs.orig/README cvs/README
--- cvs.orig/README	2008-08-03 19:51:04.000000000 +0200
+++ cvs/README	2008-08-03 13:06:47.000000000 +0200
@@ -23,44 +23,46 @@
 
 * Copyright and license notices for graphics files
 
-The following graphics files (*.ico *.xpm) in this directory are
+The following graphics files (*.ico *.xpm *.png) in this directory are
 copyrighted and subject to the
   GNU General Public License version 2
 as stated at the top of this file. They are original works except for
 the derived works noted below.
 
-Derived from the gnome-icon-theme/24x24 icon set and copyrighted as
-stated at the beginning of this file:
+Derived from the gnome-icon-theme icon set (version 2.12, sizes 24x24 and
+16x16) and copyrighted as stated at the beginning of this file:
 
-  about.xpm             from stock_about.png
-  close.xpm             from stock_close.png
-  delete-row.xpm        from stock_delete-row.png
-  edit-case.xpm         from stock_zoom.png
-  edit-cell.xpm         from stock_zoom.png
-  edit-class.xpm        from stock_zoom.png
-  exit.xpm              from stock_exit.png
-  fixed-width.xpm       from stock_insert-rows.png
-  help.xpm              from stock_help.png
-  insert-rows.xpm       from stock_insert-rows.png
-  new.xpm               from stock_new.png
-  open.xpm              from stock_open.png
-  paste-case.xpm        from stock_paste.png
-  print-case.xpm        from stock_print.png
-  print-cell.xpm        from stock_print.png
-  print-options.xpm     from stock_print-options.png
-  print-preview.xpm     from stock_print-preview.png
-  print.xpm             from stock_print.png
-  run-case.xpm          from stock_print-layout.png
-  run-cell.xpm          from stock_print-layout.png
-  save.xpm              from stock_save.png
-  saveas.xpm            from stock_save-as.png
-  varying-width.xpm     from stock_insert-rows.png
-  write_spreadsheet.xpm from stock_insert-rows.png
+  about[-16].png              from stock_about.png
+  close[-16].png              from stock_close.png
+  delete-row[-16].png         from stock_delete-row.png
+  edit-case[-16].png          from stock_zoom.png
+  edit-cell[-16].png          from stock_zoom.png
+  edit-class[-16].png         from stock_zoom.png
+  file-open[-16].png          from stock_open.png
+  file-save[-16].png          from stock_save.png
+  file-save-as[-16].png       from stock_save-as.png
+  fixed-width[-16].png        from stock_insert-rows.png
+  help[-16].png               from stock_help.png
+  insert-rows[-16].png        from stock_insert-rows.png
+  new.png                     from stock_new.png
+  new-16.png                  from stock_new-formula.png
+  paste-case[-16].png         from stock_paste.png
+  preferences[-16].png        from gnome-settings.png
+  print-case[-16].png         from stock_print.png
+  print-cell[-16].png         from stock_print.png
+  print-options[-16].png      from stock_print-options.png
+  print-preview[-16].png      from stock_print-preview.png
+  print[-16].png              from stock_print.png
+  quit[-16].png               from stock_exit.png
+  run-case[-16].png           from stock_print-layout.png
+  run-cell[-16].png           from stock_print-layout.png
+  varying-width[-16].png      from stock_insert-rows.png
+  write-spreadsheet[-16].png  from stock_insert-rows.png
 
-Derived from the gnome-icon-theme/24x24 icon set and copyrighted as
-stated at the beginning of this file:
+Derived from the gnome-icon-theme icon set (version 2.12, sizes 24x24 and
+16x16) and copyrighted as stated at the beginning of this file:
 
-  default_cell.xpm      from stock_new.png
+  default-cell[-16].png       from stock_new.png
 
 Many of these icons are used by GNU emacs, and are in the emacs cvs at
 savannah.gnu.org . The original author of this gnome icon set is Jakub
diff -ruN cvs.orig/toolbar.xrc cvs/toolbar.xrc
--- cvs.orig/toolbar.xrc	2008-08-03 19:51:04.000000000 +0200
+++ cvs/toolbar.xrc	2008-08-03 11:39:22.000000000 +0200
@@ -32,122 +32,122 @@
     <bitmapsize>24,24</bitmapsize>
     <object class="tool" name="wxID_NEW">
         <tooltip>New</tooltip>
-        <bitmap>new.xpm</bitmap>
+        <bitmap stock_id="wxART_NEW"/>
         <longhelp>Open a new file</longhelp>
     </object>
     <object class="tool" name="wxID_OPEN">
         <tooltip>Open</tooltip>
-        <bitmap>open.xpm</bitmap>
+        <bitmap stock_id="wxART_FILE_OPEN"/>
         <longhelp>Open a file</longhelp>
     </object>
     <object class="tool" name="wxID_SAVE">
         <tooltip>Save</tooltip>
-        <bitmap>save.xpm</bitmap>
+        <bitmap stock_id="wxART_FILE_SAVE"/>
         <longhelp>Save file</longhelp>
     </object>
     <object class="tool" name="wxID_PRINT">
         <tooltip>Print</tooltip>
-        <bitmap>print.xpm</bitmap>
+        <bitmap stock_id="wxART_PRINT"/>
         <longhelp>Print</longhelp>
     </object>
     <object class="tool" name="wxID_PREVIEW">
         <tooltip>Print preview</tooltip>
-        <bitmap>print-preview.xpm</bitmap>
+        <bitmap stock_id="print-preview"/>
         <longhelp>See what this document will look like when printed</longhelp>
     </object>
     <object class="tool" name="wxID_PREFERENCES">
         <tooltip>Preferences</tooltip>
-        <bitmap>preferences.xpm</bitmap>
+        <bitmap stock_id="wxART_PREFERENCES"/>
         <longhelp>Manage preferences</longhelp>
     </object>
     <object class="separator"/>
     <object class="tool" name="edit_cell">
         <tooltip>Edit cell</tooltip>
-        <bitmap>edit-cell.xpm</bitmap>
+        <bitmap stock_id="edit-cell"/>
         <longhelp>Edit selected cell</longhelp>
     </object>
     <object class="tool" name="edit_class">
         <tooltip>Edit class defaults</tooltip>
-        <bitmap>edit-class.xpm</bitmap>
+        <bitmap stock_id="edit-class"/>
         <longhelp>Edit selected cell's class defaults</longhelp>
     </object>
     <object class="tool" name="edit_case">
         <tooltip>Edit case defaults</tooltip>
-        <bitmap>edit-case.xpm</bitmap>
+        <bitmap stock_id="edit-case"/>
         <longhelp>Edit case defaults</longhelp>
     </object>
     <object class="separator"/>
     <object class="tool" name="run_cell">
         <tooltip>Run cell</tooltip>
-        <bitmap>run-cell.xpm</bitmap>
+        <bitmap stock_id="run-cell"/>
         <longhelp>Run selected cell</longhelp>
     </object>
 <!-- SOMEDAY !! One might imagine wanting to run all cells in a class.
     <object class="tool" name="run_class">
         <tooltip>Run class</tooltip>
-        <bitmap>run-class.xpm</bitmap>
+        <bitmap stock_id="run-class"/>
         <longhelp>Run all cells in selected cell's class</longhelp>
     </object>
 -->
     <object class="tool" name="run_case">
         <tooltip>Run case</tooltip>
-        <bitmap>run-case.xpm</bitmap>
+        <bitmap stock_id="run-case"/>
         <longhelp>Run all cells</longhelp>
     </object>
     <object class="separator"/>
     <object class="tool" name="print_cell">
         <tooltip>Print cell</tooltip>
-        <bitmap>print-cell.xpm</bitmap>
+        <bitmap stock_id="print-cell"/>
         <longhelp>Run and print selected cell</longhelp>
     </object>
 <!-- SOMEDAY !! One might imagine wanting to run all cells in a class.
     <object class="tool" name="print_class">
         <tooltip>Print class</tooltip>
-        <bitmap>print-class.xpm</bitmap>
+        <bitmap stock_id="print-class"/>
         <longhelp>Run and print all cells in selected cell's class</longhelp>
     </object>
 -->
     <object class="tool" name="print_case">
         <tooltip>Print case</tooltip>
-        <bitmap>print-case.xpm</bitmap>
+        <bitmap stock_id="print-case"/>
         <longhelp>Run and print all cells</longhelp>
     </object>
     <object class="tool" name="print_spreadsheet">
         <tooltip>Print case to spreadsheet</tooltip>
-        <bitmap>write_spreadsheet.xpm</bitmap>
+        <bitmap stock_id="write-spreadsheet"/>
         <longhelp>Run and print all cells to a spreadsheet file</longhelp>
     </object>
     <object class="separator"/>
     <object class="tool" name="paste_census">
         <tooltip>Paste census</tooltip>
-        <bitmap>paste-case.xpm</bitmap>
+        <bitmap stock_id="paste-case"/>
         <longhelp>Paste census data from clipboard</longhelp>
     </object>
     <object class="tool" name="add_cell">
         <tooltip>Add cell</tooltip>
-        <bitmap>insert-rows.xpm</bitmap>
+        <bitmap stock_id="insert-rows"/>
         <longhelp>Add a new cell with case default parameters</longhelp>
     </object>
     <object class="tool" name="delete_cells">
         <tooltip>Delete selected cell(s)</tooltip>
-        <bitmap>delete-row.xpm</bitmap>
+        <bitmap stock_id="delete-row"/>
         <longhelp>Delete selected cell(s)</longhelp>
     </object>
     <object class="separator"/>
     <object class="tool" name="column_width_varying">
         <tooltip>Varying column width</tooltip>
-        <bitmap>varying-width.xpm</bitmap>
+        <bitmap stock_id="varying-width"/>
         <longhelp>Vary each column's width to show its entire contents</longhelp>
     </object>
     <object class="tool" name="column_width_fixed">
         <tooltip>Fixed column width</tooltip>
-        <bitmap>fixed-width.xpm</bitmap>
+        <bitmap stock_id="fixed-width"/>
         <longhelp>Display all columns with the same fixed width</longhelp>
     </object>
     <object class="separator"/>
     <object class="tool" name="wxID_HELP">
         <tooltip>Help</tooltip>
-        <bitmap>help.xpm</bitmap>
+        <bitmap stock_id="wxART_HELP"/>
         <longhelp>Help</longhelp>
     </object>
 </object>
diff -ruN cvs.orig/workhorse.make cvs/workhorse.make
--- cvs.orig/workhorse.make	2008-08-03 19:51:04.000000000 +0200
+++ cvs/workhorse.make	2008-08-03 12:16:17.000000000 +0200
@@ -805,7 +805,7 @@
 touchstone_dir := $(exec_prefix)/touchstone
 
 data_files := \
-  $(wildcard $(addprefix $(src_dir)/,*.xml *.xpm *.xrc *.xsd *.xsl)) \
+  $(wildcard $(addprefix $(src_dir)/,*.png *.xml *.xpm *.xrc *.xsd *.xsl)) \
 
 help_files := \
   $(wildcard $(addprefix $(htmldir)/,*.html *.hhc *.hhp)) \