diff -x Root -x Repository -x Entries -x '*.orig' -u -N -r ./src/daemon/driver/driverInterface.ml ./src/daemon/driver/driverInterface.ml
--- ./src/daemon/driver/driverInterface.ml	2004-05-03 10:22:25.000000000 +0200
+++ ./src/daemon/driver/driverInterface.ml	2004-06-02 19:12:00.000000000 +0200
@@ -849,7 +849,7 @@
 (* version 3 *)
           
           | P.MessageToClient (num, mes) ->
-              lprintf "MessageToClient(%d,%s)\n" num mes;
+              BLOG INFO : "MessageToClient(%d,%s)\n" (num) (mes) ELOG;
               let c = client_find num in
               client_say c mes
           
diff -x Root -x Repository -x Entries -x '*.orig' -u -N -r ./src/networks/donkey/donkeyClient.ml ./src/networks/donkey/donkeyClient.ml
--- ./src/networks/donkey/donkeyClient.ml	2004-05-05 22:56:49.000000000 +0200
+++ ./src/networks/donkey/donkeyClient.ml	2004-06-02 19:29:14.000000000 +0200
@@ -1780,7 +1780,7 @@
               client_send c (
                 M.SayReq "[AUTOMATED WARNING] Sorry, you have not understood P2P");
               set_client_state c BlackListedHost;
-              lprintf "Client[%d]: banned (%s)\n" (client_num c) ban;
+              BLOG INFO : "Client[%d]: banned (%s)\n" (client_num c) (ban) ELOG;
               raise Not_found
             end)
       ["Mison"]; (* People who don't understand P2P themselves please leave this list alone *)
@@ -2084,7 +2084,7 @@
         end     
       
       else begin
-          (* lprintf "***** CONNECTION PREVENTED by limitations *****\n"; *)
+          BLOG DEBUG : "***** CONNECTION PREVENTED by limitations *****\n" ELOG;
           Unix.close s
         end;
   | _ -> 
diff -x Root -x Repository -x Entries -x '*.orig' -u -N -r ./src/networks/donkey/donkeyNeighbours.ml ./src/networks/donkey/donkeyNeighbours.ml
--- ./src/networks/donkey/donkeyNeighbours.ml	2004-04-16 19:14:55.000000000 +0200
+++ ./src/networks/donkey/donkeyNeighbours.ml	2004-06-02 19:36:47.000000000 +0200
@@ -118,7 +118,7 @@
               raise Continue
             end
       | File_possible ->
-          lprintf "DonkeyNeighbours: WARNING, source was unknown\n";
+          BLOG DEBUG : "DonkeyNeighbours: WARNING, source was unknown\n" ELOG;
           if time + 1800 < last_time () then raise Continue
       | File_not_found ->
           incr_propositions kind File_not_found;
diff -x Root -x Repository -x Entries -x '*.orig' -u -N -r ./src/networks/donkey/donkeyOvernet.ml ./src/networks/donkey/donkeyOvernet.ml
--- ./src/networks/donkey/donkeyOvernet.ml	2004-05-04 10:59:05.000000000 +0200
+++ ./src/networks/donkey/donkeyOvernet.ml	2004-06-02 19:30:43.000000000 +0200
@@ -915,8 +915,9 @@
             
             List.iter (fun p -> add_search_peer s p; add_global_peer p) peers
           end
-        with _ -> ()
-	(* lprintf "NO SUCH SEARCH: %s\n" (Md4.to_string md4); *)
+        with _ ->
+	    BLOG DEBUG : "NO SUCH SEARCH: %s\n" (Md4.to_string md4) ELOG;
+	    ()
       end
   | OvernetNoResult(md4) -> 
       if !verbose_overnet && debug_client other_ip then
diff -x Root -x Repository -x Entries -x '*.orig' -u -N -r ./src/networks/donkey/donkeyProtoCom.ml ./src/networks/donkey/donkeyProtoCom.ml
--- ./src/networks/donkey/donkeyProtoCom.ml	2004-05-05 22:55:37.000000000 +0200
+++ ./src/networks/donkey/donkeyProtoCom.ml	2004-06-02 19:34:24.000000000 +0200
@@ -321,13 +321,11 @@
   
 let server_send_share compressed sock msg =
 
-(*  lprintf "SEND %d FILES TO SHARE" (List.length msg); lprint_newline ();*)
+  BLOG DEBUG : "SEND %d FILES TO SHARE\n" (List.length msg) ELOG;
   
   let max_len = !!client_buffer_size - 100 - 
     TcpBufferedSocket.remaining_to_write sock in
-  if !verbose then begin
-      lprintf "SENDING SHARES"; lprint_newline ();
-    end;
+  BLOG DEBUG (!verbose) : "SENDING SHARES\n" ELOG;
   
   Buffer.clear buf;
   let s = 
diff -x Root -x Repository -x Entries -x '*.orig' -u -N -r ./src/utils/net/http_server.ml ./src/utils/net/http_server.ml
--- ./src/utils/net/http_server.ml	2004-03-18 00:42:32.000000000 +0100
+++ ./src/utils/net/http_server.ml	2004-06-02 19:22:04.000000000 +0200
@@ -344,9 +344,7 @@
                 }
             |  _ -> 
                 let tmpfile = Filename.temp_file "http_" "" in
-                if !debug then begin
-                    lprintf "WARNING: saving to file %s" tmpfile; lprint_newline ();
-                  end;
+                BLOG DEBUG (!debug) : "WARNING: saving to file %s\n" (tmpfile) ELOG;
                 let oc = open_out tmpfile in
                 let rec iter n empty_line =
                   if n > !upload_limit then 
@@ -394,9 +392,7 @@
             end;
           raise Exit
       | [] -> 
-          if !debug then begin
-              lprintf "NO LINES"; lprint_newline ();
-            end;
+          BLOG DEBUG (!debug) : "NO LINES\n" ELOG;
           raise Exit
     in
     if !end_boundary_found then field :: previous else
@@ -408,7 +404,7 @@
 
 let parse_post_args f len req b =
 (* parse post args *)
-  lprintf "CALL HANDLR"; lprint_newline ();
+  lprintf "CALL HANDLR\n";
   let s = String.sub b.rbuf b.rpos len in
   Select.buf_used b len;
   let args = Url.cut_args s in
@@ -417,12 +413,12 @@
   f b req
   
 let check_len f len b pos2 =
-  lprintf "check_len: len %d rlen %d" len b.rlen; lprint_newline ();
+  lprintf "check_len: len %d rlen %d\n" len b.rlen;
   if b.rlen >= len then f b
 
 let complete_post_request ( f : handler ) buf request =
   let len = request.options.content_length in
-  lprintf "check_len: len %d rlen %d" len buf.rlen; lprint_newline ();
+  lprintf "check_len: len %d rlen %d\n" len buf.rlen;
   if buf.rlen >= len then
     parse_post_args f len request buf
   else
@@ -580,10 +576,7 @@
               stream_out_string oc 
                 (Printf.sprintf "Content-Type: %s\n" t)
             with _ -> 
-(*
-  lprintf "No content-type for %s" ext;
-lprint_newline ();
-  *)
+                BLOG DEBUG : "No content-type for %s\n" (ext) ELOG;
                 iter exts
       in
       iter exts
@@ -603,9 +596,7 @@
                 (Printf.sprintf "Content-Encoding: %s\n"
                   encoding)
             with _ -> 
-(*                lprintf "No encoding for %s" ext;
-lprint_newline ();
-  *)
+	        BLOG DEBUG : "No encoding for %s\n" (ext) ELOG;
                 iter exts
       in
       iter exts
@@ -635,8 +626,7 @@
     stream_out_string buf ans;
     at_write_end buf.fd_task shutdown;
   with e ->
-      lprintf "No such file: %s (%s)" file (Printexc2.to_string e); 
-      lprint_newline ();
+      lprintf "No such file: %s (%s)\n" file (Printexc2.to_string e); 
       simple_error_404 buf;
       at_write_end buf.fd_task shutdown
 *)      
@@ -730,11 +720,11 @@
 
   if len+clen > max_refill sock then
     TcpBufferedSocket.set_max_output_buffer sock (len + clen);
-(*  lprintf "HTTPSEND: [%s]\n" (String.escaped s); - log commented out *)
+    BLOG DEBUG : "HTTPSEND: [%s]\n" (String.escaped s) ELOG;
   TcpBufferedSocket.write_string sock s;
     
   if request.request <> "HEAD" then begin
-(*        lprintf "HTTPSEND: [%s]\n" (String.escaped c); - log commented out *)
+      BLOG DEBUG : "HTTPSEND: [%s]\n" (String.escaped c) ELOG;
       TcpBufferedSocket.write_string sock c;
       match request.reply_stream with
         None -> ()
@@ -749,8 +739,8 @@
   let end_pos = b.pos + b.len in
   let new_pos = end_pos - nread in
   let new_pos = maxi 0 (new_pos - 1) in
-(*  lprintf "received [%s]\n" (String.escaped 
-      (String.sub b.buf new_pos nread)); - log commented out *)
+  BLOG DEBUG : "received [%s]\n" (String.escaped 
+      (String.sub b.buf new_pos nread)) ELOG;
   let rec iter i =
     let end_pos = b.pos + b.len in
     if i < end_pos then
@@ -852,8 +842,8 @@
     x, Some y, Some z
   with 
   | e ->
-      lprintf "Exception %s for range [%s]\n" 
-        (Printexc2.to_string e) range;
+      BLOG DEBUG : "Exception %s for range [%s]\n" 
+        (Printexc2.to_string e) (range) ELOG;
       raise e
 
 let parse_range range =